;BCC27

Graphics 640,480,32,2
SetBuffer BackBuffer()

;Vars
Global LeW, LeH
Dim Level(24, 9)
Dim Coin(24, 9)

Global Timer = CreateTimer(60)
Global CurLevel$ = "01", LName$, SName$, NLevel$
Global CX#, CY#, PX#, PY#, PSX#, PSY#, EX, EY, Leben, Gold, GoldMax, WSpeed# = .025, SPX, SPY, Campaign, LevelRow$
Global PDie = 0, PWin = 0

AutoMidHandle 1
Tls = LoadAnimImage("Tls.png", 64, 64, 0, 16)
Obj = LoadAnimImage("Obj.png", 64, 64, 0, 16)
MaskImage Obj, 255, 0, 255

Water = CreateImage(64, 64, 6)
For A = 0 To 5
	CopyRect 0, 0, 64, 64, 32, A*6-64, ImageBuffer(Tls, 4), ImageBuffer(Water, A)
	CopyRect 0, 0, 64, 64, 32, A*6, ImageBuffer(Tls, 4), ImageBuffer(Water, A)
	CopyRect 0, 0, 64, 64, 32, A*6+64, ImageBuffer(Tls, 4), ImageBuffer(Water, A)
Next

Global NF = LoadFont("Times New Roman", 18, 1)
Global BF = LoadFont("Courier New", 36, 1)

;Sounds
Dim Sound(10)
For S = 1 To 10
	SN$ = Replace(RSet(S, 2), " ", "0")
	Sound(S) = LoadSound(SN$+".wav")
Next
Local WF#
Dim Count(3)

;Game
;ClsColor 75, 150, 200
Repeat
	MH = MouseHit(1)
	Cls
	
	WF# = WF# + .1
	If WF# >= 6 WF = 0
	
	If Leben > 15
		Score = Score + 50*(Leben-15)
		Leben = 15
	EndIf
	
	TileBlock Tls, -CX, -CY, 2
	For X = 0 To LeW
		For Y = 0 To LeH
			If Level(X, Y) > 0
				TX1 = 320+PX-CX-16:TY1 = 240+PY-CY-16:TX2 = 320+X*64-CX-32:TY2 = 240+Y*64-CY-32
				If 320+X*64 -CX > -64 And 320+X*64 -CX < 704 And 240+Y*64 - CY > -64 And 240+Y*64 - CY < 564
					If Level(X, Y) <> 10 And Level(X, Y) <> 5
						DrawBlock Tls, 320+X*64-CX, 240+Y*64-CY, Level(X, Y)-1
					ElseIf Level(X, Y) = 5
						DI Water, 320+X*64-CX, 240+Y*64-CY, Floor(WF)
					Else
						If Level(1, 1) > 0
							DrawBlock Tls, 320+X*64-CX, 240+Y*64-CY, Level(1, 1)-1
							If Y-1 >= 0 If Level(X, Y-1) = 5 DI Water, 320+X*64-CX, 240+Y*64-CY, Floor(WF)
						EndIf
						DI Tls, 320+X*64-CX, 240+Y*64-CY, Level(X, Y)-1
					EndIf
					If Level(X, Y) = 10 And RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
						PDie = 1
					ElseIf Level(X, Y) = 5 And RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
						PSX# = PSX# / 32 * 31
						PSY# = PSY# + WSpeed#
					ElseIf Level(X, Y) = 11 And RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
						PWin = 1
					ElseIf Level(X, Y) = 12 And RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
						PSX# = PSX# * 1.02
						PSY# = PSY# * 1.02
					ElseIf Level(X, Y) = 5 Or Level(X, Y) = 6 Or Level(X, Y) = 7 Or Level(X, Y) = 13 Or Level(X, Y) = 14 Or Level(X, Y) = 15 Or Level(X, Y) = 16
						If RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
							Winkels# = 270 - (ATan2(TX2+32-(320+PX-CX), TY2+32-(240+PY-CY)) + 360) Mod 360
							Col = 0
							If Winkels# >= -45 And Winkels# <= 45 And IC(X+1, Y)
								PSX = -PSX
								PX = PX+PSX
								PX = PX+PSX
								Col = 1
							ElseIf Winkels# <= 225 And Winkels >= 135 And IC(X-1, Y)
								PSX = -PSX
								PX = PX+PSX
								PX = PX+PSX
								Col = 1
							EndIf
							If Winkels# >= 45 And Winkels# <= 135 And IC(X, Y+1)
								PSY = -PSY
								PY = PY+PSY
								PY = PY+PSY
								Col = 1
							ElseIf Winkels# >= 225 Or Winkels <= -45 And IC(X, Y-1)
								PSY = -PSY
								PY = PY+PSY
								PY = PY+PSY
								Col = 1
							EndIf
							TX1 = 320+PX-CX-16:TY1 = 240+PY-CY-16
							If Col = 1 And RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
								PX = PX + Cos(Winkels)*1
								PY = PY + Sin(Winkels)*1
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
			If Coin(X, Y) = 1
				TX1 = 320+PX-CX-16:TY1 = 240+PY-CY-16:TX2 = 320+X*64-CX-32:TY2 = 240+Y*64-CY-32
				DrawImage Obj, 320+X*64-CX, 240+Y*64-CY, 8
				If RO(TX1, TY1, 32, 32, TX2, TY2, 64, 64) = 1
					Coin(X, Y) = 0
					Gold = Gold + 1
					PlaySound Sound(7)
				EndIf
			EndIf
		Next
	Next
	Select GameState
		Case 0	;Menu
			SetFont BF
			Text 320, 30, "BCC27", 1, 1
			
			SetFont NF
			If Button(160, 120, "Spiel Starten", 320) = 1 And MH = 1
				CurLevel = "01"
				LoadLevel("Level"+CurLevel)
				
				Leben = 2
				Score = 0
				Gold = 0
				GameState = 1
				
				PDie = 0
				PSX = 0
				PSY = 0
				
				FlushMouse()
				FlushKeys()
				LevelRow$ = "Standard - Campaign; "
			ElseIf Button(160, 140, "Eigenes Level Laden", 320) = 1 And MH = 1
				Cls
				LoadLevel(Input("Levelname: "))
				
				Leben = 2
				Score = 0
				Gold = 0
				
				GameState = 1
				
				PDie = 0

				PSX = 0
				PSY = 0

				FlushMouse()
				FlushKeys()
				LevelRow$ = "Custom - Unknown; "
			ElseIf Button(160, 160, "Spiel Beenden", 320) = 1 And MH = 1
				End
			EndIf
		Case 1	;Game
			;Zeichnen
			DI Obj, 32, 446, 13
			For CurL = 2 To Leben
				DI Obj, CurL*32, 446, 0
			Next
			
			DI Obj, 320+(PX-CX), 240+(PY-CY), 13
			If Leben > 1 DI(Obj, 320+(PX-CX), 240+(PY-CY), 0)
			Color 0, 0, 0
			Rect 320+(PX-CX)-12, 240+(PY-CY)-12, 24, 24, 0
			Color 255, 255, 255
			
			For A = 39 To 0 Step -1
				Color A*6.375, 255-A*6.375, 0
				Oval 600-A, 440-A, A*2, A*2
			Next
			
			DrawImage Obj, 600+PSX*4, 440+PSY*4, 10
			
			;Minimap
			Color 204, 204, 204
			Rect 572, 0, 72, 72
			Color 153, 153, 153
			Rect 574, 2, 68, 68
			Color 102, 102, 102
			Rect 576, 4, 64, 64
			
			Viewport 576, 4, 64, 64
			MPX = PX/64:MPY = PY/64
			MCX = CX/64:MCY = CY/64
			For X = 0 To LeW
				For Y = 0 To LeH
					If Level(X, Y) = 10
						Color 255, 0, 0
					ElseIf Level(X, Y) = 5
						Color 0, 255, 255
					ElseIf Level(X, Y) = 11
						Color 0, 255, 0
					ElseIf Level(X, Y) = 12
						Color 127, 127, 127
					ElseIf Level(X, Y) = 5 Or Level(X, Y) = 6 Or Level(X, Y) = 7 Or Level(X, Y) = 13 Or Level(X, Y) = 14 Or Level(X, Y) = 15 Or Level(X, Y) = 16
						Color 255, 255, 255
					Else
						Color 0, 0, 0
					EndIf
					Rect 608+(X-MCX)*8, 36+(Y-MCY)*8, 8, 8
					If Coin(X,Y) = 1
						Color 255, 127, 0
						Rect 608+(X-MCX)*8+2, 36+(Y-MCY)*8+2, 4, 4
					EndIf
				Next
			Next
			Color 255, 255, 0
			Rect 608+(MPX-MCX)*8, 36+(MPY-MCY)*8, 8, 8
			Viewport 0, 0, 640, 480
			
			;Berechnung
			If PSX <> 0 Or PSY <> 0
				If PSX > 10 PSX = 10:If PSY > 10 PSY = 10
				If PSX < -10 PSX = -10:If PSY < -10 PSY = -10
				PX = PX + PSX:PY = PY + PSY
				CX = CX + (PX-CX)  * 0.125:CY = CY + (PY-CY) * 0.125
				PSX = PSX * 0.98:PSY = PSY * 0.98
			EndIf
			
			Winkel# = 270 - ATan2((CX-PX)+(320-MouseX()), (CY-PY)+(240-MouseY()))
			If MouseDown(1) = 1
				PSX# = PSX# + Cos(Winkel#)*.15
				PSY# = PSY# + Sin(Winkel#)*.15
			EndIf
			If KeyDown(200) PSY# = PSY# - .15
			If KeyDown(208) PSY# = PSY# + .15
			If KeyDown(203) PSX# = PSX# - .15
			If KeyDown(205) PSX# = PSX# + .15
			
			;Sterben, Gewinnen
			If PDie = 1
				PDie = 0
				
				Color 51, 51, 51
				Rect 160, 80, 320, 240
				Color 102, 102, 102
				Rect 160, 80, 320, 240, 0
				
				Color 255, 255, 255
				SetFont BF
				Text 320, 100, "Geplatzt", 1, 1
				
				SetFont NF
				Text 160, 150, "Punke: ":Text 320, 150, RSet((Score+Gold*10),35)
				Text 160, 170, "Punkte beim Start: ":Text 320, 170, RSet(Score,35)
				
				Text 160, 210, "Goldmnzen gesammelt: ":Text 320, 210, RSet(Gold,30)+"/"+GoldMax
				
				While Not MouseHit(1)
					Flip 0
					WaitTimer Timer
				Wend
				
				Leben = Leben - 1
				If Leben > 0
					LoadLevel(CurLevel)
					Gold = 0
					GameState = 1
					PDie = 0
					PSX = 0
					PSY = 0
					FlushMouse()
					FlushKeys()
				Else
					GameState = 0
					FlushMouse()
					FlushKeys()
				EndIf
			EndIf
			If PWin = 1
				Color 51, 51, 51
				Rect 160, 80, 320, 240
				Color 102, 102, 102
				Rect 160, 80, 320, 240, 0
				
				If NLevel$ <> ""
					Screen("Geschafft")
					
					Leben = Leben + 1
					If Campaign = 1
						LoadLevel("Level"+NLevel$)
					Else
						LoadLevel(NLevel$)
					EndIf
					Score = Score + Gold * 10
					Gold = 0
					GameState = 1
					PSX = 0
					PSY = 0
					PWin = 0
				Else
					Screen("Level Pack zu Ende")
					
					Leben = Leben + 1
					Score = 0
					Gold = 0
					GameState = 0
					PSX = 0
					PSY = 0
					PWin = 0
					FlushMouse()
					FlushKeys()
				EndIf
			EndIf
			If KeyHit(1)
				PDie = 1
				Leben = 0
			EndIf
	End Select
	
	Flip 0
	WaitTimer Timer
Forever

Function Button(X, Y, T$, W=-1)
	If W = -1
		Width = StringWidth(T$) + 4
	Else
		Width = W
		If Width < StringWidth(T$) + 4 Width = StringWidth(T$) + 4
	EndIf
	Height = FontHeight()

	Color 51, 51, 51:Rect X, Y, Width, Height, 0
	Color 127, 127, 127:Rect X+1, Y+1, Width-2, Height-2
	Color 255, 255, 255:Text X+Width/2, Y+Height/2, T$, 1, 1

	If MouseX() >= X And MouseX() < X+Width And MouseY() >= Y And MouseY() < Y+Height
		Color 255, 255, 255:Rect X, Y, Width, Height, 0
		Color 127, 127, 127:Rect X+1, Y+1, Width-2, Height-2
		Color 255, 255, 255:Text X+Width/2, Y+Height/2, T$, 1, 1
		Return 1
	EndIf
	Return 0
End Function

;Screen
Function Screen(Title$)
	Color 255, 255, 255
	SetFont BF
	Text 320, 100, Title$, 1, 1
	
	SetFont NF
	Text 160, 150, "Punke: ":Text 320, 150, RSet((Score+Gold*10),35)
	Text 160, 170, "Punkte beim Start: ":Text 320, 170, RSet(Score,35)
	Text 160, 210, "Goldmnzen gesammelt: ":Text 320, 210, RSet(Gold,30)+"/"+GoldMax
	
	While Not MouseHit(1)
		Flip 0
		WaitTimer Timer
	Wend
	FlushMouse()
	FlushKeys()
End Function

;Level
Function LoadLevel(Name$)
	Stream = ReadFile("Lvl/"+Name$+".lvl")
	If Stream <> 0
		CurLevel = Name$
		LName$ = ReadString(Stream)
		SName$ = ReadString(Stream)
		NLevel$ = ReadString(Stream)
		LeW = ReadInt(Stream)-1
		LeH = ReadInt(Stream)-1
		PX = ReadInt(Stream)*64
		PY = ReadInt(Stream)*64
		SPX=PX:SPY=PY
		Dim Level(LeW, LeH)
		For Y = 0 To LeH
			For X = 0 To LeW
				Level(X, Y) = ReadByte(Stream)
			Next
		Next
		CC = ReadInt(Stream)
		GoldMax = CC
		Dim Coin(LeW, LeH)
		For A = 1 To GoldMax
			XC = ReadInt(Stream)
			YC = ReadInt(Stream)
			Coin(XC, YC) = 1
		Next
		Campaign = ReadInt(Stream)
		CloseFile Stream
		Color 51, 51, 51
		Rect 10, 80, 620, 160
		Color 102, 102, 102
		Rect 10, 80, 620, 160, 0
		
		Color 255, 255, 255
		SetFont BF
		Text 320, 100, "Level", 1, 1
		
		SetFont NF
		Text 320, 150, LName$, 1, 1
		Text 320, 190, SName$, 1, 1
		Text 160, 210, "Goldmnzen gesamt: ":Text 320, 210, CC
		
		While Not MouseHit(1)
			Flip 0
			WaitTimer Timer
		Wend
		FlushMouse()
		FlushKeys()
		
		LevelRow$ = LevelRow$ + LName$ + "; "
	Else
		RuntimeError "Level "+Name$+" not found"
	EndIf
End Function

Function RO(X1, Y1, W1, H1, X2, Y2, W2, H2):Return RectsOverlap(X1, Y1, W1, H1, X2, Y2, W2, H2):End Function
Function DI(I, X, Y, F=0):DrawImage(I, X, Y, F):End Function
Function IC(X, Y)
	If X >= 0 And Y >= 0 And X < LeW And Y < LeH
		If Level(X, Y) = Level(X, Y) = 5 Or Level(X, Y) = 6 Or Level(X, Y) = 7 Or Level(X, Y) = 13 Or Level(X, Y) = 14 Or Level(X, Y) = 15 Or Level(X, Y) = 16
			Return 0
		EndIf
		Return 1
	EndIf
	Return 0
End Function