Framework brl.math
Import brl.GLMax2D
Import brl.timer
Import brl.Blitz
Import brl.linkedlist
Import brl.random
Import brl.Retro
Import brl.Audio
Import brl.WAVLoader
Import brl.DirectSoundAudio
Import brl.Stream
Import brl.PNGLoader
Import brl.pixmap
Type Tb
	Field x:Int = 1024, y:Float, size:Int, im:Int, f:Float, a:Float
End Type
Global blist:TList = CreateList()
Type Td
	Field x:Int, y:Int, MSG:String, count:Int = 60
End Type
Global dlist:TList = CreateList()
Local snd:TSound[10]
snd[0] = LoadSound("Snd01_uhmm.wav")
snd[1] = LoadSound("Snd02_Uiii.wav")
snd[2] = LoadSound("Snd03_boom.wav")
snd[3] = LoadSound("Snd04_brlbrl.wav")
snd[4] = LoadSound("Snd05_brrb.wav")
snd[5] = LoadSound("Snd06_jump.wav")
snd[6] = LoadSound("Snd07_pling.wav")
snd[7] = LoadSound("Snd08_kawum.wav")
snd[8] = LoadSound("Snd09_kapling.wav")
snd[9] = LoadSound("Snd10_plung.wav")
Global channel:TChannel[10]
For Local sr:Int = 0 To 9
	channel[sr] = AllocChannel()
Next
Global muk:Float[10, 15, 16], img:Timage, img2:Timage, in:TStream = ReadFile("g"), takt, fers, time = MilliSecs() + 125, tmr:Ttimer = CreateTimer(60), gamestate, sch1:Int, chan
For x = 0 To 9
	For f = 0 To 14
		For t = 0 To 15
			muk[x, f, t] = in.ReadFloat()
		Next
	Next
Next
in.close()

img = LoadAnimImage("IMG_Tiles.png", 64, 64, 0, 16, FILTEREDIMAGE | MIPMAPPEDIMAGE)
img2 = LoadAnimImage("IMG_Alpha.png", 64, 64, 0, 16)
AppTitle = "Faloutt 3"
Graphics(1024, 768)
SetBlend(ALPHABLEND)
Delay(1000)
Cls
PlaySound(snd[8])
SetScale(4, 4)
DrawText("Nindento", 512 - (35 * 4), 384 - (7 * 4))
Flip
Delay(2000)
Cls
Flip
Delay(2000)
SetClsColor(100, 100, 255)
Global px:Int, py:Int, pr:Int, tmr2:Int, md:Int, score:Int, life:Int, speed:Float
While Not KeyHit(KEY_ESCAPE)
	tmr.Wait()
	Cls
	md = MouseHit(1)
	px = px - 1
	If px < - 256 Then px = 0
	pr = pr + 1 Mod 360
	SetScale(1, 1)
	SetColor(255, 255, 255)
	DP(img, 0 + px, 512 + py, 256, 256, 1)
	DP(img, 256 + px, 512 + py, 256, 256, 1)
	DP(img, 512 + px, 512 + py, 256, 256, 1)
	DP(img, 768 + px, 512 + py, 256, 256, 1)
	DP(img, 1024 + px, 512 + py, 256, 256, 1)
	For ads = 0 To 40
		DP(img, (ads * 32) + px, 496 + py, 32, 32, 0)
	Next
	SetHandle(64, 64)
	SetRotation(pr)
	DP(img2, 512, 496 - 55 + py, 128, 128, 7)
	SetHandle(0, 0)
	SetRotation(0)
	For Local cTb:Tb = EachIn blist
		cTb.x = cTb.x - 1
		cTb.y = cTb.y + cTb.f
		If cTb.y + cTb.size > 496 Then cTb.y = 496 - cTb.size
		SetAlpha(cTb.a)
		DP(img2, cTb.x, cTb.y + py, cTb.size, cTb.size, cTb.im)
		Local del:Int = 0
		If md = 1 And MouseX() > cTb.x And MouseX() < cTb.x + cTb.size And MouseY() > cTb.y And MouseY() < cTb.y + cTb.size Then
			del = 1
			If cTb.im = 8 Then score = score - (5 * cTb.size) ; msg("Score:-" + (3 * cTb.size), cTb.x, cTb.y)
			If cTb.im = 9 Then life = life + (cTb.size / 10.0) ; msg("Life:+" + Int((cTb.size / 10.0)), cTb.x, cTb.y)
			If cTb.im = 11 Then speed = speed + (3 * cTb.size) ; msg("Speed:+" + (3 * cTb.size), cTb.x, cTb.y)
			If score < 0 Then score = 0
			md = 0
		EndIf
		If cTb.x - (cTb.size / 2) < 512 Then
			del = 1
			If cTb.im = 8 Then score = score + (3 * cTb.size) ; msg("Score:+" + (3 * cTb.size), cTb.x, cTb.y)
			If cTb.im = 10 Then life = life - (1 * cTb.size) ; msg("Life:-" + (1 * cTb.size), cTb.x, cTb.y)
			If cTb.im = 11 Then speed = speed - (2 * cTb.size) ; msg("Speed:-" + (2 * cTb.size), cTb.x, cTb.y)
		EndIf
		If del = 1 Then blist.Remove(cTb)
	Next
	SetAlpha(1)
	speed = speed - (0.2 + (score / 2500.0))
	If speed < 0 Then speed = 0
	For Local cTd:Td = EachIn dlist
		cTd.y = cTd.y - 1
		cTd.count = cTd.count - 1
		DrawText(cTd.msg, cTd.x, cTd.y)
		If cTd.count < 0 Then dlist.Remove(cTd)
	Next
	SetColor(255, 0, 0)
	If life > 100 Then life = 100
	DrawRect(30, 30, life * 3, 25)
	SetScale(3.5, 3.5)
	Select gamestate
		Case 0
			SetColor(0, 0, 255)
			DrawText("Faloutt 3 - the czech version", 100, 200)
			sch1 = sch1 + 1
			If sch1 = 0 Then SetColor(0, 0, 255) Else SetColor(255, 0, 0) ;sch1 = -1
			DrawText("> Start Game", 300, 400)
			If KeyDown(KEY_RETURN) Or md Then
				gamestate = 1
				tmr2 = MilliSecs() + Rnd(1000, 5000)
				score = 0
				speed = 1000
				life = 100
			EndIf
		Case 1
			SetColor(0, 255, 0)
			DrawText("Score: " + score, 100, 100)
			If tmr2 <= MilliSecs() Then
				tmr2 = MilliSecs() + Rnd(Int(speed), Int(speed) * 5)
				Local nTb:Tb = New Tb
				blist.AddLast(nTb)
				nTb.size = Rnd(10, 50)
				nTb.im = Rnd(8, 12)
				nTb.f = Rnd(1, 2)
				nTb.a = Rnd(0, 1)
			EndIf
			If life < 0 Then gamestate = 0 ;life = 0;blist.Clear()
	End Select
	
	If time <= MilliSecs() Then
		time = MilliSecs() + 125
		takt = takt + 1
		If takt >= 16 Then takt = 0 ; fers = fers + 1
			If fers >= 15 Then fers = 0
		For Local x23:Int = 0 To 9
			If muk[x23, fers, takt] > 0 Then
				chan = chan + 1
				If chan > 9 Then chan = 0
				channel[chan].SetRate(muk[x23, fers, takt])
				PlaySound(snd[x23], channel[chan])
			EndIf
		Next
	EndIf
	Flip
Wend
Function msg(txt:String, x:Int, y:Int)
	Local nTd:Td = New Td
	dlist.AddLast(nTd)
	nTd.x = x
	nTd.y = y
	nTd.msg = txt
End Function
Function DP(bild:Timage, x:Float, y:Float, width:Float, height:Float, frame:Int = 0)
	Local nowscale_X:Float
	Local nowscale_Y:Float
	GetScale(nowscale_X, nowscale_Y)
	Local nowhandle_X:Float
	Local nowhandle_Y:Float
	GetHandle(nowhandle_X, nowhandle_Y)
	Local factorx:Float = width / bild.width
	Local factory:Float = height / bild.height
	SetScale(factorx * nowscale_X, factory * nowscale_Y)
	Local entferung:Float = Sqr((nowhandle_X) ^ 2 + (nowhandle_Y) ^ 2)
	Local winkel:Float = -ATan2(nowhandle_X, nowhandle_Y) + 180
	DrawImage(bild, x + (Cos(GetRotation() - winkel) * (entferung * nowscale_X)), y + (Sin(GetRotation() - winkel) * (entferung * nowscale_Y)), frame)
	SetScale(nowscale_x, nowscale_Y)
End Function