;Allgemeines BlaBla
Global gfx_w=1024
Global gfx_h=768
Graphics gfx_w,gfx_h,0,2
SetBuffer BackBuffer()
AppTitle "BCC27 - Butterflies vs Skulls v0.95 - von Eingeproggt, 06-2009"
TFormFilter 0
SetFont LoadFont("Arial",18,1)
Global timer=CreateTimer(30)

Text 10,10,"Laden...":Flip

;Graphiken
Global tileset=LoadAnimImage("SDK\IMG_Tiles.png",64,64,0,3)
Global items=LoadAnimImage("SDK\IMG_Masked.png",64,64,0,16)
MaskImage items,255,0,255

;Totenkopf schwarz einfrben
Global skull=CreateImage(64,64)
MidHandle skull
buff=ImageBuffer(skull)
CopyRect 0,0,64,64,0,0,ImageBuffer(items,15),buff
For x=0 To 63
	For y=0 To 63
		col=ReadPixel(x,y,buff)
		WritePixel x,y,col<>-65281,buff ;Macht den Pixel bei grner Farbe schwarz und bei anderer Farbe (Pink) transparent (Maskfarbe schwarz)
	Next
Next

;Rotierte Bilder fr Spieler und Schsse
Dim img(2,120)
For i=0 To 2
	img(i,0)=CreateImage(64,64)
	If i=0 Then frame=1  ;Spieler
	If i=1 Then frame=4  ;Gegnerschuss
	If i=2 Then frame=12 ;Spielerschuss
	CopyRect 0,0,64,64,0,0,ImageBuffer(items,frame),ImageBuffer(img(i,0))
	MaskImage img(i,0),255,0,255
	MidHandle img(i,0)
	For j=1 To 120
		img(i,j)=CopyImage(img(i,0))
		RotateImage img(i,j),j*3
		MaskImage img(i,j),255,0,255
	Next
Next

;Bentigte Vars
Global map_w,map_h
Dim map(0,0)
Global map_x,map_y
Dim temp(0,0)

Global player_x,player_y,player_w#,player_leben

Global mhit,mx,my

Global edit_mode,overbutton

Type figur
	Field x,y
	Field timer,leben
End Type
Global fig.figur

Type schuss
	Field x,y,w#
	Field typ,timer
End Type
Global s.schuss

Type job
	Field startx,starty
	Field eventx,eventy
	Field typ,done
End Type
Global job.job
Global aktjob.job

Type file
	Field name$
End Type

Type health
	Field x,y
End Type
Global h.health

menuanzeige$="Viel Spass bei 'Butterflies vs Skulls'!"

;Hauptschleife
Repeat
	UserInput()
	
	If game Then
		;Map zeichnen
		For x=map_x/64 To (map_x+gfx_w)/64+1
			If x>=0 And x<=map_w-1 Then
				For y=map_y/64 To (map_y+gfx_h)/64+1
					If y>=0 And y<=map_h-1 Then DrawBlock tileset,x*64-map_x,y*64-map_y,map(x,y)
				Next
			EndIf
		Next
		
		;Figuren zeichnen
		For fig=Each figur
			If fig\x-map_x>=0 And fig\x-map_x<=gfx_w And fig\y-map_y>=0 And fig\y-map_y<=gfx_h Then
				DrawImage skull,fig\x-map_x,fig\y-map_y
				If game=1 Then
					DrawLeben(fig\x-map_x,fig\y-map_y-20,fig\leben,10)
				EndIf
			EndIf
		Next
		
		;Heilpakete
		For h=Each health
			If h\x-map_x+32>=0 And h\x-map_x+32<=gfx_w And h\y-map_y+32>=0 And h\y-map_y+32<=gfx_h Then
				DrawImage items,h\x-map_x,h\y-map_y,10
				If game=1 Then
					If CircleColl(player_x,player_y,25,h\x+32,h\y+32,25) Then
						player_leben=20
						Delete h
					EndIf
				EndIf
			EndIf
		Next
		
		;"Auftraggeber"
		ok=True
		For job=Each job
			DrawImage img(0,0),job\startx-map_x,job\starty-map_y
			If job\typ=1 And aktjob=job And job\done=0 Then DrawImage items,job\eventx-map_x,job\eventy-map_y,3
			If job\done=1 Then DrawImage items,job\startx-32-map_x,job\starty-32-map_y,6
			If game=2 Then Line job\startx-map_x,job\starty-map_y,job\eventx-map_x,job\eventy-map_y
			If game=1 And job\done=0 Then
				If CircleColl(player_x,player_y,25,job\startx,job\starty,25) Then
					If aktjob=Null Then aktjob=job
				EndIf
			EndIf
			If job\done<>1 Then ok=False
		Next
		If ok And game=1 Then
			If First job<>Null Or First figur=Null Then
				;Spiel gewonnen
				menuanzeige$="Herzlichen Glckwunsch, Sie haben die Map gemeistert!"
				game=0
			EndIf
		EndIf
		
		;Spieler
		DrawImage img(0,player_w/3),player_x-map_x,player_y-map_y
		If game=2 Then
			Text player_x-map_x,player_y-map_y,"Spieler",1
		Else
			DrawLeben(player_x-map_x,player_y-map_y,player_leben,20)
		EndIf
		
		;Auftragsverwaltung
		If aktjob<>Null Then
			Color 100,100,100
			Rect 0,0,400,20,1
			Color 255,255,255
			Rect 0,0,400,20,0
			If aktjob\typ=1 Then
				txt$="Hole das Paket und bringe es dem Schmetterling"
			ElseIf aktjob\typ=2 Then
				txt$="Tte den Totenkopf an gegebener Position"
			Else
				txt$="Triff dich mit einem Kameraden"
			EndIf
			Text 5,2,txt$
			
			If aktjob\typ=1 And aktjob\done=-1 Then
				w=ATan2(aktjob\starty-player_y,aktjob\startx-player_x) Mod 360
				
				If CircleColl(player_x,player_y,25,aktjob\startx,aktjob\starty,25) Then
					aktjob\done=1
					aktjob=Null
				EndIf
			Else
				w=ATan2(aktjob\eventy+32-player_y,aktjob\eventx+32-player_x) Mod 360
				
				If aktjob\typ=1 Then
					If CircleColl(player_x,player_y,25,aktjob\eventx+32,aktjob\eventy+32,25) Then
						If aktjob\typ=1 Then
							aktjob\done=-1
						Else
							aktjob\done=1
							aktjob=Null
						EndIf
					EndIf
				ElseIf aktjob\typ=3 Then
					If CircleColl(player_x,player_y,25,aktjob\eventx,aktjob\eventy,25) Then
						aktjob\done=1
						aktjob=Null
					EndIf
				Else
					;Job-Typ 2 berprfung
					ok=False
					For fig=Each figur
						If fig\x=aktjob\eventx And fig\y=aktjob\eventy Then
							ok=True
							Exit
						EndIf
					Next
					If Not ok Then
						aktjob\done=1
						aktjob=Null
					EndIf
				EndIf
			EndIf
			
			x=player_x-map_x+Cos(w)*80
			y=player_y-map_y+Sin(w)*80
			Line player_x-map_x,player_y-map_y,x,y
			Line x,y,x-Cos(w+30)*20,y-Sin(w+30)*20
			Line x,y,x-Cos(w-30)*20,y-Sin(w-30)*20
		EndIf
		
		If game=1 Then
			;Spielersteuerung
			If KeyDown(30) And Game_GetMap((player_x-10),player_y)=0 Then player_x=player_x-10
			If KeyDown(32) And Game_GetMap((player_x+10),player_y)=0 Then player_x=player_x+10
			If KeyDown(17) And Game_GetMap(player_x,(player_y-10))=0 Then player_y=player_y-10
			If KeyDown(31) And Game_GetMap(player_x,(player_y+10))=0 Then player_y=player_y+10
			
			player_w=(ATan2((player_y-map_y)-my,(player_x-map_x)-mx)+290) Mod 360 ;360-70=290 wegen gedrehtem Schmetterling
			
			If player_x<32 Then player_x=32
			If player_y<32 Then player_y=32
			If player_x>map_w*64 Then player_x=map_w*64
			If player_y>map_h*64 Then player_y=map_h*64
			
			If mhit Then ;Or KeyHit(57)
				s=New schuss
				s\x=player_x
				s\y=player_y
				s\w=(player_w+250) Mod 360
			EndIf
			
			;Scrolling der Map
			map_x=player_x-gfx_w/2
			map_y=player_y-gfx_h/2
			
			;Schsse verwalten
			For s=Each schuss
				s\x=s\x+Cos(s\w)*20
				s\y=s\y+Sin(s\w)*20
				If s\typ Then
					If s\x-map_x>=0 And s\x-map_x<=gfx_w And s\y-map_y>=0 And s\y-map_y<=gfx_h Then
						DrawImage img(1,((s\w+130) Mod 360)/3),s\x-map_x,s\y-map_y
						If CircleColl(player_x,player_y,25,s\x,s\y,12) Then
							player_leben=player_leben-1
							If player_leben=0 Then
								;Spiel verloren
								menuanzeige$="Das Schmetterlingsland wird deinetwegen untergehen! Du hast verloren"
								game=0
							EndIf
							Delete s
						EndIf
					EndIf
				Else
					DrawImage img(2,(s\w/3)),s\x-map_x,s\y-map_y
					For fig=Each figur
						If CircleColl(fig\x,fig\y,25,s\x,s\y,12) Then
							fig\leben=fig\leben-1
							If fig\leben=0 Then Delete fig
							Delete s
							Exit
						EndIf
					Next
				EndIf
				If s<>Null Then
					s\timer=s\timer+1
					If s\timer=30 Then Delete s
				EndIf
			Next
			
			;Gegner-KI
			For fig=Each figur
				If (fig\x-player_x)*(fig\x-player_x)+(fig\y-player_y)*(fig\y-player_y)<550*550 Then
					If MilliSecs()-fig\timer>1000 Then
						s=New schuss
						s\x=fig\x
						s\y=fig\y
						s\w=(ATan2(player_y-fig\y,player_x-fig\x)+360) Mod 360
						s\typ=1
						fig\timer=MilliSecs()
					EndIf
				EndIf
			Next
			
		Else
			;Editormodus
			If Button(0,gfx_h-50,"Neu",100) Then
				;Neue Karte
				NewMap()
			EndIf
			If Button(100,gfx_h-50,"Laden",100) Then
				;Laden
				LoadDialog()
			EndIf
			If Button(200,gfx_h-50,"Speichern",100) Then
				;Karte speichern
				FlushKeys
				Cls
				name$=Input("Dateiname: ")
				If name$<>"" Then SaveMap(name$)
				FlushKeys
			EndIf
			If Button(300,gfx_h-50,"Mapgre",100) Then
				;Mapgre ndern
				Repeat
					x=Input("Neue Breite der Map (2-255): ")
				Until x>=2 And x<=255
				Repeat
					y=Input("Neue Breite der Map (2-255): ")
				Until y>=2 And y<=255
				ResizeMap(x,y)
			EndIf
			
			If Button(gfx_w-100,gfx_h-50,"Wasser",100) Then edit_mode=1
			If Button(gfx_w-100,gfx_h-25,"Gras",100) Then edit_mode=2
			
			If Button(0,gfx_h-25,"Gegner",100) Then edit_mode=3
			If Button(100,gfx_h-25,"Spieler",100) Then edit_mode=4
			If Button(200,gfx_h-25,"Auftrag",100) Then edit_mode=5
			If Button(300,gfx_h-25,"Heilpaket",100) Then edit_mode=8
			If Button(400,gfx_h-25,"Entfernen",100) Then edit_mode=7
			
			Select edit_mode
				Case 1
					DrawBlock tileset,((mx+map_x)/64)*64-map_x,((my+map_y)/64)*64-map_y,2
					If MouseDown(1) And (Not overbutton) Then Edit_SetMap(mx,my,2)
				Case 2
					DrawBlock tileset,((mx+map_x)/64)*64-map_x,((my+map_y)/64)*64-map_y,0
					If MouseDown(1) And (Not overbutton) Then Edit_SetMap(mx,my,0)
				Case 3
					DrawImage skull,mx,my
					If mhit And Edit_GetMap(mx,my)=0 Then
						fig=New figur
						fig\x=mx+map_x
						fig\y=my+map_y
					EndIf
				Case 4
					DrawImage img(0,0),mx,my
					If mhit And Edit_GetMap(mx,my)=0 Then
						player_x=mx+map_x
						player_y=my+map_y
						edit_mode=0
					EndIf
				Case 5
					Rect mx-32,my-32,64,64,0
					Text mx,my,"Start",1,1
					If mhit And Edit_GetMap(mx,my)=0 Then NewJob()
				Case 6
					Rect mx,my,64,64,0
					Text mx+32,my+32,"Ziel",1,1
					job=Last job
					job\eventx=mx+map_x
					job\eventy=my+map_y
					If mhit And Edit_GetMap(mx,my)=0 Then
						If job\typ=3 Then
							NewJob()
						ElseIf job\typ=2 Then
							fig=New figur
							fig\x=mx+map_x
							fig\y=my+map_y
							edit_mode=0
						Else
							edit_mode=0
						EndIf
					EndIf
				Case 7
					Line mx-32,my-32,mx+32,my+32
					Line mx-32,my+32,mx+32,my-32
					If mhit Then
						For fig=Each figur
							If CircleColl(mx+map_x,my+map_y,25,fig\x,fig\y,25) Then
								Delete fig
								Exit
							EndIf
						Next
						For job=Each job
							If CircleColl(mx+map_x,my+map_y,25,job\startx,job\starty,25) Then
								Delete job
								Exit
							EndIf
						Next
						For h=Each health
							If CircleColl(mx+map_x,my+map_y,25,h\x+32,h\y+32,25) Then
								Delete h
								Exit
							EndIf
						Next
					EndIf
				Case 8
					DrawImage items,mx-32,my-32,10
					If mhit And Edit_GetMap(mx,my)=0 Then
						h=New health
						h\x=mx+map_x-32
						h\y=my+map_y-32
					EndIf
			End Select
			
			;Scrolling der Map
			If KeyDown(203) Then map_x=map_x-20
			If KeyDown(205) Then map_x=map_x+20
			If KeyDown(200) Then map_y=map_y-20
			If KeyDown(208) Then map_y=map_y+20
		EndIf
		
		If KeyHit(1) Then
			If game=2 Then
				If edit_mode<>0 Then
					edit_mode=0
				Else
					game=0
				EndIf
			Else
				game=0
			EndIf
		EndIf
	Else
		For i=1 To 10
			Text gfx_w/2+Sin(menuvar+i*36)*300,300+i*30,menuanzeige$,1,1
		Next
		menuvar=menuvar+1
		
		If Button(gfx_w/2-200,70,"Spielen") Then
			If LoadDialog() Then game=1
		EndIf
		If Button(gfx_w/2-200,100,"Editor") Then
			NewMap()
			game=2
		EndIf
		If Button(gfx_w/2-200,130,"Ende") Then End
	EndIf
	
	WaitTimer timer
	Flip 0:Cls
Forever

Function NewMap()
	Delete Each figur
	Delete Each job
	Delete Each health
	FlushKeys
	Cls
	
	Repeat
		x=Input("Breite der Map (2-255): ")
	Until x>=2 And x<=255
	map_w=x
	Repeat
		y=Input("Breite der Map (2-255): ")
	Until y>=2 And y<=255
	map_h=y
	Dim map(map_w,map_h)
	
	tile=Input("Ausgangstile (0=Gras, 1=Wasser):")
	If tile>=1 Then tile=2
	For x=0 To map_w-1
		For y=0 To map_h-1
			map(x,y)=tile
		Next
	Next
	
	player_x=0
	player_y=0
	map_x=0
	map_y=0
End Function

Function SaveMap(file$)
	If Right(file$,4)<>".dat" Then file$=file$+".dat"
	Local writer=WriteFile("maps\"+file$)
	
	WriteByte writer,map_w
	WriteByte writer,map_h
	For x=0 To map_w-1
		For y=0 To map_h-1
			WriteByte writer,map(x,y)
		Next
	Next
	
	WriteShort writer,player_x
	WriteShort writer,player_y
	
	For fig=Each figur
		WriteByte writer,1
		WriteShort writer,fig\x
		WriteShort writer,fig\y
	Next
	WriteByte writer,0
	
	For job=Each job
		WriteByte writer,1
		WriteShort writer,job\startx
		WriteShort writer,job\starty
		WriteShort writer,job\eventx
		WriteShort writer,job\eventy
		WriteByte writer,job\typ
	Next
	WriteByte writer,0
	
	For h=Each health
		WriteByte writer,1
		WriteShort writer,h\x
		WriteShort writer,h\y
	Next
	WriteByte writer,0
	
	CloseFile writer
End Function

Function LoadMap(file$)
	Local reader=ReadFile("maps\"+file$)
	;If reader=0 Then RuntimeError("Die Datei '"+file$+"' konnte nicht geladen werden")
	
	Delete Each figur
	Delete Each schuss
	Delete Each job
	Delete Each health
	
	map_w=ReadByte(reader)
	map_h=ReadByte(reader)
	Dim map(map_w-1,map_h-1)
	
	For x=0 To map_w-1
		For y=0 To map_h-1
			map(x,y)=ReadByte(reader)
		Next
	Next
	
	player_x=ReadShort(reader)
	player_y=ReadShort(reader)
	
	While ReadByte(reader)=1
		fig=New figur
		fig\x=ReadShort(reader)
		fig\y=ReadShort(reader)
		fig\leben=10
	Wend
		
	While ReadByte(reader)=1
		job=New job
		job\startx=ReadShort(reader)
		job\starty=ReadShort(reader)
		job\eventx=ReadShort(reader)
		job\eventy=ReadShort(reader)
		job\typ=ReadByte(reader)
	Wend
	
	While ReadByte(reader)=1
		h=New health
		h\x=ReadShort(reader)
		h\y=ReadShort(reader)
	Wend
	
	CloseFile reader
	
	player_leben=20
End Function

Function LoadDialog()
	Delete Each file
	Local dir=ReadDir("maps")
	Repeat
		file$=NextFile(dir)
		If file$="" Then Exit
		If Right(file$,4)=".dat" Then
			fil.file=New file
			fil\name$=file$
		EndIf
	Forever
	CloseDir dir
	
	Cls
	
	If First file=Null Then
		Text gfx_w/2,70,"Keine Maps vorhanden",1
	Else
		Text gfx_w/2,70,"Spiel laden:",1
	EndIf
	
	Repeat
		UserInput()
		y=100
		For fil=Each file
			If Button(gfx_w/2-200,y,fil\name$) Then
				LoadMap(fil\name$)
				Return True
			EndIf
			y=y+30
		Next
		If Button(gfx_w/2-200,y+10,"Zurck") Then Exit
		
		WaitTimer timer
		Flip 0
	Until KeyHit(1)
	Return False
End Function

Function Button(x,y,txt$,w=400)
	Color 100,100,100
	Rect x,y,w,25,1
	If mx>x And mx<x+w And my>y And my<y+25 Then
		overbutton=True
		Color 150,150,150
		Rect x,y,w,25,1
		If mhit Then
			mhit=False
			Color 255,255,255
			Return True
		EndIf
	EndIf
	Color 255,255,255
	Rect x,y,w,25,0
	Text x+w/2,y+4,txt$,1
End Function

Function UserInput()
	mx=MouseX()
	my=MouseY()
	mhit=MouseHit(1)
	overbutton=False
End Function

Function Edit_SetMap(x,y,tile)
	If x+map_x>0 And x+map_x<map_w*64 And y+map_y>0 And y+map_y<map_h*64 Then
		map((x+map_x)/64,(y+map_y)/64)=tile
	EndIf
End Function

Function Edit_GetMap(x,y)
	If x+map_x>0 And x+map_x<map_w*64 And y+map_y>0 And y+map_y<map_h*64 Then
		Return map((x+map_x)/64,(y+map_y)/64)
	EndIf
End Function

Function Game_GetMap(x,y)
	x=x/64
	y=y/64
	If x>=0 And x<map_w And y>=0 And y<map_h Then
		Return map(x,y)
	Else
		Return -1
	EndIf
End Function

Function NewJob()
	job=New job
	job\startx=mx+map_x
	job\starty=my+map_y
	Repeat
		UserInput()
		Text gfx_w/2,70,"Aufgabenart auswhlen:",1
		If Button(gfx_w/2-200,100,"Gegenstand abholen") Then job\typ=1
		If Button(gfx_w/2-200,130,"Totenkopf tten") Then job\typ=2
		If Button(gfx_w/2-200,160,"Schmetterling treffen") Then job\typ=3
		WaitTimer timer
		Flip 0
	Until job\typ<>0
	edit_mode=6
End Function

Function CircleColl(x1,y1,r1,x2,y2,r2)
	Local dist=(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
	Local min=(r1+r2)*(r1+r2)
	Return dist<min
End Function

Function DrawLeben(x,y,leben,max)
	DrawBlockRect items,x-20,y-6,12,25,(leben/Float(max))*41,12,5
	Rect x-20,y-6,41,12,0
End Function

Function ResizeMap(w,h)
	Dim temp(map_w,map_h)
	For x=0 To map_w-1
		For y=0 To map_h-1
			temp(x,y)=map(x,y)
		Next
	Next
	Dim map(w,h)
	map_w=w
	map_h=h
	For x=0 To map_w-1
		For y=0 To map_h-1
			map(x,y)=temp(x,y)
		Next
	Next
	map_x=0
	map_y=0
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D